//escape a string like 'fun*2.Co' for a regExpr
function escapeRegExp(str) {
  return str.replace(/[\-[\]/{}()*+?.\\^$|]/g, '\\$&')
}

//sometimes text-replacements can be ambiguous - words used multiple times..
const smartReplace = function (all, text, result) {
  if (!text || !all) {
    return all
  }

  if (typeof all === 'number') {
    all = String(all)
  }
  text = escapeRegExp(text)
  //try a word-boundary replace
  let reg = new RegExp('\\b' + text + '\\b')
  if (reg.test(all) === true) {
    all = all.replace(reg, result)
  } else {
    //otherwise, fall-back to a much messier, dangerous replacement
    // console.warn('missing \'' + text + '\'');
    all = all.replace(text, result)
  }
  return all
}

export default smartReplace
